package code;

/*  BodySSEndMsg.java
 * 
 *  Inform the receiver that a SS was removed from  a body connection
 *
 * (C) Copyright 2006 -- See the file COPYRIGHT for additional details
 */

import java.io.Serializable;

public class BodySSEndMsg implements Serializable
{
  private SubscriptionSet ss;
  

 /** 
 *  Constructor 
 **/ 
  public BodySSEndMsg(SubscriptionSet ss){
    this.ss = ss;
  }

 /** 
 *  Equals 
 **/ 

  public boolean equals(Object o) {
    if (o instanceof BodySSEndMsg){
      BodySSEndMsg other = (BodySSEndMsg) o;
      if (this.ss.equals(other.ss)){
        return true;
      }
    }
    return false;
  }

 /** 
 *  GetMethod 
 **/ 
    public SubscriptionSet getSS(){
      return ss;
    }

 /** 
 *  toString 
 **/ 
  public String toString(){
    return "BodySSEndMsg: " + ss;
  }
}
//---------------------------------------------------------------------------
/* $Log: BodySSEndMsg.java,v $
/* Revision 1.2  2006/11/13 23:39:36  nalini
/* fixed typo in toString()
/*
/* Revision 1.1  2006/10/31 21:43:32  nalini
/* added control msgs to body streams
/*
*/
//---------------------------------------------------------------------------
