package code;

/*  BodySSStartMsg.java
 * 
 *  Inform the receiver that a SS was added to a body connection
 *
 * (C) Copyright 2006 -- See the file COPYRIGHT for additional details
 */
import java.io.Serializable;

public class BodySSStartMsg implements Serializable
{
  private SubscriptionSet ss;
  

 /** 
 *  Constructor 
 **/ 
  public BodySSStartMsg(SubscriptionSet ss){
    this.ss = ss;
  }

 /** 
 *  Equals 
 **/ 

  public boolean equals(Object o) {
    if (o instanceof BodySSStartMsg) {
      BodySSStartMsg other = (BodySSStartMsg) o;
      if (this.ss.equals(other.ss)){
        return true;
      }
    }
    return false;
  }

 /** 
 *  GetMethod 
 **/ 
    public SubscriptionSet getSS(){
      return ss;
    }

 /** 
 *  toString 
 **/ 
  public String toString(){
    return "BodySSStartMsg: " + ss;
  }
}
//---------------------------------------------------------------------------
/* $Log: BodySSStartMsg.java,v $
/* Revision 1.1  2006/10/31 21:43:32  nalini
/* added control msgs to body streams
/*
*/
//---------------------------------------------------------------------------
