package code;
//package utils.junit;

import junit.textui.TestRunner;
import junit.framework.*;
import java.util.*;

/**
 * TBD: Update class name
 */
public class NodeIdUnit extends TestCase {
  public static final String TEST_ALL_TEST_TYPE = "UNIT";
  
  /**
   * Basic constructor - called by the test runners.
   * TBD: Update constructor name to match class
   */
  public NodeIdUnit (final String s) {
    super (s);
  }

  /*
   * Fixtures are run before and after each test case
   * to set up environment in which tests must run.
   */
  protected void setUp() throws Exception{
    super.setUp();
    /* 
     * TBD: Insert other fixture code here
     * e.g., this.objectUnderTest = new ClassToBeTested(...);
     */
  }

  protected void tearDown() throws Exception{
    /* 
     * TBD: Insert other fixture cleanup code here
     */
    super.tearDown();
  }

  /* 
   * TBD: Insert functions called testX for some X
   */
  public void testAll(){
    /*
     * Your code here. Create instance of class to be tested
     * and test it...
     */
    NodeId nodeId1 = null;
    NodeId nodeId2 = null;
    NodeId nodeId3 = null;

    Env.verifyAssertEnabled();
    nodeId1 = new NodeId(35);
    nodeId2 = new NodeId(42);
    nodeId3 = new NodeId(35);
    assert(nodeId1.equals(nodeId3));
    assert(nodeId1.equals(nodeId1));
    assert(!nodeId2.equals(nodeId1));
    assert(nodeId1.hashCode() == nodeId1.hashCode());
    assert(nodeId1.hashCode() == nodeId3.hashCode());

    assert(nodeId1.toString().equals("35"));
    assert(nodeId1.compareTo(nodeId2) == -1);
    assert(nodeId2.compareTo(nodeId1) == 1);
    assert(nodeId1.compareTo(nodeId1) == 0);
    assert(nodeId2.compareTo(nodeId2) == 0);
    assert(!nodeId1.equals(nodeId2));
    assert(!nodeId2.equals(nodeId1));
    assert(nodeId1.equals(nodeId1));
    assert(nodeId2.equals(nodeId2));

    assert(nodeId1.leq(nodeId1));
    assert(nodeId1.leq(nodeId2));
    assert(!nodeId2.leq(nodeId1));
    assert(nodeId1.leq(nodeId3));

    assert(!nodeId1.gt(nodeId1));
    assert(!nodeId1.gt(nodeId2));
    assert(nodeId2.gt(nodeId1));
    assert(!nodeId1.gt(nodeId3));
  }
  
  /*
   * "new TestSuite(Class c)" constructs a test suite
   * containg every method whose name begins with "test"
   * 
   * TBD: update class name
   */
  public static Test suite(){
    TestSuite suite = new TestSuite(NodeIdUnit.class);
    return suite;
  }


  /*
   * main() lets us run just this set of unit tests
   * from the comand line (you can also invoke 
   * the testrunner on this class and it will find
   * the suite())
   *
   * TBD: update class name
   */
  public static void main(String s[]) {
    String name = "NodeIdUnit";
    System.err.print(name + " self test begins...");
    TestRunner tr = new TestRunner();
    tr.doRun(suite());
    System.err.println(name + " self test succeeds");
  }

}
