package code;
/* NullRandomAccessState
 *
 * For performance experiments
 *
 * (C) Copyright -- See the file COPYRIGHT for additional details
 */

import java.io.*;
import java.util.*;


public class NullRandomAccessState extends RandomAccessState{
    

  
 /** 
 *  NullRandomAccessState -- constructor 
 *  
 **/ 
  public 
  NullRandomAccessState()
    throws IOException{
    super();
   
  }

 /** 
 *  finalizer 
 **/ 
  protected void finalize(){
  }


 /** 
 *  close() -- flush everything to disk and close. 
 **/ 
  public void close(){
 
  }


 /** 
 *  sync() -- make sure that data are safely on disk 
 **/ 
  public void sync()  throws IOException{
    
  }


 /** 
 *  read() -- read up to maxLen bytes at specified offset of objId 
 *  
 **/ 
  public BodyMsg 
  read(ObjId objId, long offset, long maxLen, boolean exactOffset)
    throws NoSuchEntryException, EOFException, ReadOfInvalidRangeException,
	   ReadOfEmbargoedWriteException,
	   ReadOfHoleException{
    return null;

  }


 /** 
 *  readMeta() -- read the metadata for the specified offset of  
 *                 the specified file 
 *  
 *  returns 
 *     PreciseInval on success 
 *     throws NoSuchObjectException if objId does not exist (includes 
 *          case where delete of objId is more recent than any write 
 *          to objId) 
 *     throws EOFException if offset is larger than any write to 
 *          objId (since the last delete) 
 **/ 
  public PreciseInv
  readMeta(ObjId objId, long offset)
    throws NoSuchEntryException, EOFException,
	   ReadOfHoleException{
    return null;
  }





 /** 
 *  applyInval() -- apply the specified invalidation (which 
 *                  may be bound) to the state 
 *  
 *  Side effect: updates currentVV 
 *  
 *  return the offet of the first newly-valid byte (if any) 
 *    or -1 (NO_NEW_VALID_BYES) if no new bytes became valid.  
 *    (Bytes can become valid if the inval is bound) 
 **/ 
  public long
  applyInval(PreciseInv pi){
    return -999;
  }

  
 /** 
 *  applyBody() -- apply the specified body to the state 
 *  
 **/ 
  public long
  applyBody(BodyMsg b){
    return -999;
  }



 /** 
 *  delete() -- delete the specified objId (at the specified time) 
 *  
 **/ 
  public void
  delete(ObjId objId, AcceptStamp accept){
  }




 /** 
 *  getVV() -- return the current VV 
 **/ 
  public VV
  getVV(){
    return null;
  }


 /** 
 *  getVV() -- return the current VV for specified node 
 **/ 
  public long
  getVV(NodeId id){
    return -999;
  }
   



 /** 
 *  scanForUpdates() -- scan through all elements in the store 
 *    and insert any element that (a) intersects is and (b) is newer 
 *    than startVV into upq 
 *  
 **/ 
  public void
  scanForUpdates(UpdatePriorityQueue upq, SubscriptionSet ss, VV startVV)
    throws IOException{

  }


 /** 
 *  Ship the intersected RAS records 
 **/ 
  public void shipRAS(TaggedOutputStream s,
                      SubscriptionSet cpPath,
                      //String[] exclChildNames,
                      VV cpStartVV,
		      boolean withBody)
    throws IOException{
    
  }

 /** 
 *  update PerObjStateDB and PerRangeStateDB according to the inputStream 
 **/ 
  public boolean
    updateRAS(LinkedList s, SubscriptionSet path, long txnSize)
    throws IOException{
    return true;
  }
 /** 
 *  debargo an embargoed write 
 **/ 
  public boolean debargo(DebargoMsg dm)
  throws IOException{

    return true;
  }



 /** 
 *  getAuxCheckpointStuff() -- return stuff needed for the full checkpoint 
 **/ 
  public byte[] getAuxCheckpointStuff(String keyS) 
    throws NoSuchEntryException, IOException{
    throw new NoSuchEntryException("Null RAS");

  }

 /** 
 *  putAuxCheckpointStuff() -- return stuff needed for the full checkpoint 
 **/ 
  public void putAuxCheckpointStuff(String keyS, byte[] valueB) 
    throws IOException{
  }



 /** 
 *  destroyAllStateCleanup -- delete all of the files we created (for testing) 
 **/ 
  public static void
  destroyAllStateCleanup(String path){
  }

 
}


