package code;

 /** 
 *  Implementation of a static PreciseSet controller. Because this 
 *  implementation does not break PreciseSets, it ignores all method calls. 
 **/ 

public class StaticPSController implements PSController{

 /** 
 *  Called when the caller is about to apply an invalidate message to 
 *  all overlapping PreciseSets 
 **/ 
  public void
  notifyApplyingInvOverlap(GeneralInv gi, VVMap startVVs, AllPreciseSets aps){
    // Do nothing
  }

 /** 
 *  Called when the caller is about to apply an invalidate message to 
 *  all non-overlapping PreciseSets 
 **/ 
  public void
  notifyApplyingInvNonOverlap(GeneralInv gi,
                              VVMap startVVs,
                              AllPreciseSets aps){
    // Do nothing
  }
}
