package code.lasr.db;
import code.simulator.SyncPacket;

import com.sleepycat.bind.tuple.TupleBinding;
import com.sleepycat.bind.tuple.TupleInput;
import com.sleepycat.bind.tuple.TupleOutput;

import com.sleepycat.je.Environment;
import com.sleepycat.je.EnvironmentConfig;
import com.sleepycat.je.DatabaseEntry;
import com.sleepycat.je.Database;
import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.DatabaseConfig;
import com.sleepycat.je.Cursor;
import com.sleepycat.je.OperationStatus;
import com.sleepycat.bind.tuple.IntegerBinding;
import com.sleepycat.bind.serial.SerialBinding;
import com.sleepycat.bind.serial.StoredClassCatalog;
import java.io.UnsupportedEncodingException;

import java.io.File;
import java.io.IOException;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;

public class BufferBinding extends TupleBinding{
  
  public void objectToEntry(Object object, TupleOutput to){
      if(object instanceof byte[]){
        byte[] buf = (byte[])object;
        to.writeInt(buf.length);
        to.write(buf);
      }
   
  }

  public Object entryToObject(TupleInput ti){
    try{
      int size = ti.readInt();
      byte[] buf = new byte[size];
      ti.read(buf);
      return buf;
    }catch(IndexOutOfBoundsException e){
      e.printStackTrace();
      System.exit(1);
    }
    return null;
  }

  
}
