package code.security.application.MapShare.trace;

import code.AcceptStamp;
import code.BodyMsg;
import code.Env;
import code.GeneralInv;
import code.NodeId;
import code.ObjId;
import code.PreciseSet;
import code.StreamId;
import code.SubscriptionSet;
import code.VV;
import code.security.application.MapShare.AccessControl;
import code.security.application.MapShare.MapController;

public class TraceMapController extends MapController{

  TraceListener traceListener;
  public TraceMapController(AccessControl accessControl){
    super(accessControl);
    // TODO Auto-generated constructor stub
  }

  public TraceMapController(TraceListener tl){
    // TODO Auto-generated constructor stub
    traceListener = tl;
  }
  
  
 /** 
 *  Fake method 
 **/ 
  public void informReceiveInval(GeneralInv inv , NodeId senderId)
  {
    System.out.println("informReceiveInval called back");
    System.out.println("UpdateCVV called");
    traceListener.updateCVV();
    System.out.println("UpdateCVV returned");
    
  }
  
 /** 
 *  Fake method 
 **/ 
  public void informLocalWrite(ObjId objId, long offset, long length,
                               AcceptStamp as,
                               boolean isBound,
                               boolean isEmbargoed)
  {
    System.out.println("informLocalWrite called back");
    System.out.println("UpdateCVV called");
    traceListener.updateCVV();
    System.out.println("UpdateCVV returned");
    
  }

  public void
  informCheckpointStreamInitiated(NodeId senderNodeId, 
                                  String cpPath,
                                  String[] exclChildNames,
                                  VV vvStart,
                                  boolean placeholderWriterSet){
    System.out.println("informCheckpointStreamInitiated called back");
    System.out.println("UpdateCVV called");
    traceListener.updateCVV();
    System.out.println("UpdateCVV returned");
    
  }

 /** 
 *  inform a Checkpoint Stream terminated called in CPRecvWorker 
 **/ 
  public void
  informCheckpointStreamTerminated(NodeId senderNodeId, 
                                   String cpPath,
                                   String[] exclChildNames,
                                   VV vvStart, 
                                   boolean placeholderWriterSet){
    System.out.println("informCheckpointStreamTerminated called back");
    System.out.println("UpdateCVV called");
    traceListener.updateCVV();
    traceListener.connectionTerminated();
    System.out.println("UpdateCVV returned");
    
  }

 /** 
 *  inform a Checkpoint Stream apply status called in CPRecvWorker 
 **/ 
  public void
  informCheckpointStreamReceiveStatus(NodeId senderNodeId, 
                                      String cpPath,
                                      String[] exclChildNames,
                                      VV vvStart, 
                                      boolean applyStatus,
                                      boolean placeholderWriterSet){
    System.out.println("informCheckpointStreamReceiveStatus called back");
    System.out.println("UpdateCVV called");
    traceListener.updateCVV();
    System.out.println("UpdateCVV returned");
    
  }
  
 /** 
 *  Fake method 
 **/ 
  public void informInvalStreamInitiated(NodeId senderNodeId, 
                                         SubscriptionSet is,
                                         VV vvStart, 
                                         boolean placeholderWriterSet)
  {
      Env.dprintln(true, "informInvalStreamInitiated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informCommitStreamInitiated(NodeId senderNodeId)
  {
      Env.dprintln(true, "informCommitStreamInitiated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informBodyStreamInitiated(NodeId senderNodeId)
  {
      Env.dprintln(true, "informBodyStreamInitiated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informUnbindStreamInitiated(NodeId senderNodeId)
  {
      Env.dprintln(true, "informUnbindStreamInitiated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informSyncRplyStreamInitiated(NodeId senderNodeId)
  {
      Env.dprintln(true, "informSyncRplyStreamInitiated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informOutgoingInvalStreamInitiated(NodeId targetNodeId, 
                                                 VV startVV,
                                                 boolean placeholderWriterSet)
  {
      Env.dprintln(true, "informOutgoingInvalStreamInitiated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informOutgoingBodyStreamInitiated(NodeId targetNodeId, 
                                                boolean placeholderWriterSet)
  {
      Env.dprintln(true, "informOutgoingBodyStreamInitiated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }


 /** 
 *  Fake method 
 **/ 
  public void informInvalStreamTerminated(NodeId senderNodeId, 
                                          SubscriptionSet is,
                                          VV vvStart, 
                                          boolean placeholderWriterSet,
                                          StreamId sId)
  {
      Env.dprintln(true, "informInvalStreamTerminated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      traceListener.connectionTerminated();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informCommitStreamTerminated(NodeId senderNodeId)
  {
      Env.dprintln(true, "informCommitStreamTerminated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informBodyStreamTerminated(NodeId senderNodeId)
  {
      Env.dprintln(true, "informBodyStreamTerminated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informUnbindStreamTerminated(NodeId senderNodeId)
  {
      Env.dprintln(true, "informUnbindStreamTerminated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informSyncRplyStreamTerminated(NodeId senderNodeId)
  {
      Env.dprintln(true, "informSyncRplyStreamTerminated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informOutgoingInvalStreamTerminated(NodeId targetNodeId, 
                                                 SubscriptionSet is, 
                                                 VV startVV,
                                                 boolean placeholderWriterSet)
  {
      Env.dprintln(true, "informOutgoingInvalStreamTerminated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informOutgoingBodyStreamTerminated(NodeId targetNodeId, 
                                                 SubscriptionSet is,
                                                 boolean placeholderWriterSet)
  {
      Env.dprintln(true, "informOutgoingBodyStreamTerminated");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void recvSyncReply(AcceptStamp acceptStamp, NodeId sender)
  {
      Env.dprintln(true, "recvSyncReply");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
      
      
  }

 /** 
 *  Fake method 
 **/ 
  public void informReceivePushBody(BodyMsg msg)
  {
      Env.dprintln(true, "informReceivePushBody " + msg);
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }


 /** 
 *  Fake method 
 **/ 
  public void informLocalDelete(ObjId objId)
  {
      Env.dprintln(true, "informLocalDelete");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informDemandReadMiss(ObjId objId, long offset, long length)
  {
      Env.dprintln(true, "informDemandReadMiss");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

public void informReceiveDemandReply(NodeId senderNodeId, BodyMsg msg){
  Env.dprintln(true, "informReceiveDemandReadReply");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  System.out.println("UpdateCVV returned");
}

 /** 
 *  Fake method 
 **/ 
  public void informLocalReadImprecise(ObjId objId, long offset, long length)
  {
      Env.dprintln(true, "informLocalReadImprecise");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informLocalReadNoBody(ObjId objId, long offset, long length)
  {
      Env.dprintln(true, "informLocalReadNoBody");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }


 /** 
 *  Fake method 
 **/ 
  public void informLocalReadInvalid(ObjId objId, long offset, long length,
                                     AcceptStamp inval)
  {
      Env.dprintln(true, "informLocalReadInvalid:" + objId + " " + offset 
                     + " " + length + " " + inval);
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }


 /** 
 *  Fake method 
 **/ 
  public void informReceiveDemandReply(BodyMsg msg)
  {
      Env.dprintln(true, "informReceiveDemandReply");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informDemandReadHit(ObjId objId, long offset, long length)
  {
      Env.dprintln(true, "informDemandReadHit");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }
 /** 
 *  Fake method 
 **/ 
  public void informDemandImprecise(ObjId objId, 
                                    PreciseSet enclosingIS, 
                                    VV lpVV)
  {
      Env.dprintln(true, "informDemandImprecise");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informBecameImprecise(PreciseSet is)
  {
      Env.dprintln(true, "informBecameImprecise");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }

 /** 
 *  Fake method 
 **/ 
  public void informBecamePrecise(PreciseSet is)
  {
      Env.dprintln(true, "informBecamePrecise");
      System.out.println("UpdateCVV called");
      traceListener.updateCVV();
      System.out.println("UpdateCVV returned");
  }
 /** 
 **/ 
//    inform methods for send-checkpoint protocol
 /** 
 **/ 

 /** 
 *  called in SubscribeInvalWorker when !(this.omitVV < startVV) i.e 
 *  gap exist between the sender's omitVV and the requested stream's  
 *  startVV. It implies that the ongoing subscribe inval stream is  
 *  failed. 
 *  
 *  What expected in the controller is to make the decision whether 
 *  to subscribe inval from other nodes for the receiver or invoke 
 *  a subscribeCheckpoint request to the same node optionally followed  
 *  by a subscribeInval request with a higher startVV 
 **/ 
public void informGapExistForSubscribeInv(NodeId invReceiver,
                                          SubscriptionSet is,
                                          VV startVV,
                                          VV omitVV){
  Env.dprintln(true, "informGapExistForSubscribeInv");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  System.out.println("UpdateCVV returned");
}

 /** 
 *  inform Outgoing Checkpoint Stream initiated called in CPSendWorker 
 **/ 
public void
informOutgoingCheckpointStreamInitiated(NodeId targetNodeId, 
                                        String cpPath, 
                                        String[] exclChildNames,
                                        VV startVV,
                                        boolean placeholderWriterSet){
  Env.dprintln(true, "informOutgoingCheckpointStreamInitiated");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  System.out.println("UpdateCVV returned");
}
 /** 
 *  inform Outgoing Checkpoint Stream initiated called in CPSendWorker 
 **/ 
public void
informOutgoingCheckpointStreamTerminated(NodeId receiverNodeId,
                                         String cpPath,
                                         String[] exclChildNames,
                                         VV startVV, 
                                         boolean placeholderWriterSet){
  Env.dprintln(true, "informOutgoingCheckpointStreamTerminated");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  System.out.println("UpdateCVV returned");
}



 /** 
 *  inform subscribe invalidate for a certain subscription set failed 
 **/ 
public void
informSubscribeInvalFailed(NodeId senderNodeId,
                           NodeId receiverNodeId,
                           SubscriptionSet ss,
                           VV vvStart){
  Env.dprintln(true, "informSubscribeInvalFailed");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  traceListener.informSubscribeInvalSucceeded();
  System.out.println("UpdateCVV returned");
}

 /** 
 *  inform subscribe invalidate for a certain subscription set failed 
 **/ 
public void
informSubscribeInvalSucceeded(NodeId senderNodeId,
                              NodeId receiverNodeId,
                              SubscriptionSet ss,
                              VV vvStart){
  Env.dprintln(true, "informSubscribeInvalSucceeded");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  traceListener.informSubscribeInvalSucceeded();
  System.out.println("UpdateCVV returned");
}

 /** 
 *  inform SS was added to a incomming body stream 
 **/ 
public void
informSubscribeBodySucceeded(NodeId senderNodeId,
                             SubscriptionSet ss){
  Env.dprintln(true, "informSubscribeBodySucceeded");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  System.out.println("UpdateCVV returned");
}

 /** 
 *  inform SS was removed from an incomming body stream 
 **/ 
public void
informSubscribeBodyRemoved(NodeId senderNodeId,
                           SubscriptionSet ss){
  Env.dprintln(true, "informSubscribeBodyRemoved");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  System.out.println("UpdateCVV returned");
}

 /** 
 *  inform successfully adding subscriptionSet to OutgoingConnection's 
 *  invalidateIterator's interestset 
 **/ 
public void 
informOutgoingSubscribeInvalInitiated(NodeId receiverId, 
                                      SubscriptionSet subscriptionSet){
  Env.dprintln(true, "informOutgoingSubscribeInvalInitiated");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  System.out.println("UpdateCVV returned");
}

 /** 
 *  inform successfully removed subscriptionSet from 
 *  OutgoingConnection's invalIterator's interest set 
 **/ 
public void
informOutgoingSubscribeInvalTerminated(NodeId receiverId,
                                       SubscriptionSet subscriptionSet){
  Env.dprintln(true, "informOutgoingSubscribeInvalTerminated");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  System.out.println("UpdateCVV returned");
}
 /** 
 *   inform added SS to outgoing body connection's upq notifier 
 **/ 
public void
informOutgoingSubscribeBodyInitiated(NodeId receiverID, 
                                     SubscriptionSet subscriptionSet){
  Env.dprintln(true, "informOutgoingSubscribeBodyInitiated");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  System.out.println("UpdateCVV returned");
}

 /** 
 *  inform removed SS from outgoing body connection's upq notifer 
 **/ 
public void
informOutgoingSubscribeBodyTerminated(NodeId receiverId,
                                      SubscriptionSet subscriptionSet){
  Env.dprintln(true, "informOutgoingSubscribeBodyTerminated");
  System.out.println("UpdateCVV called");
  traceListener.updateCVV();
  System.out.println("UpdateCVV returned");
}

 /** 
 *  inform received DVV is not included by current VV 
 **/ 
public void
informInvalidSignature(){
        Env.dprintln(true, "informInvalidSignature");
        System.out.println("UpdateCVV called");
        traceListener.updateCVV();
        System.out.println("UpdateCVV returned");
}

 /** 
 *  inform received DVV is not included by current VV 
 **/ 
public void
informReceivedDVVNotIncluded(){
        Env.dprintln(true, "informReceivedDVVNotIncluded");
        System.out.println("UpdateCVV called");
        traceListener.updateCVV();
        System.out.println("UpdateCVV returned");
}
 /** 
 *  inform received DVV is not included by current VV 
 **/ 
public void
informReceivedSHUnmatched(){
        Env.dprintln(true, "informReceivedSHUnmatched");
        System.out.println("UpdateCVV called");
        traceListener.updateCVV();
        System.out.println("UpdateCVV returned");
}  
 /** 
 *  inform received DVV is not included by current VV 
 **/ 
public void
informReceivedBodyUnmatched(){
        Env.dprintln(true, "informReceivedBodyUnmatched");
        System.out.println("UpdateCVV called");
        traceListener.updateCVV();
        System.out.println("UpdateCVV returned");
}  

}
