package code.simulator.protocolFilters;

import code.AcceptVV;
import java.util.HashMap;
import java.util.TreeSet;
import java.util.Arrays;

import code.NodeId;

public class GCProposal implements Comparable, Proposal{
  final AcceptVV omitVV;
//  final byte[] objectStateHash;
  final NodeId bid;
  final int epoch;
//  final HashMap<SimBranchID, TreeSet<SimPreciseInv>> unverifiableWrites;
  
  public GCProposal(AcceptVV omitVV, NodeId bid, int epoch){
    this.bid = bid;
    this.omitVV  = omitVV;
    this.epoch = epoch;
  }
//  public GCProposal(HashMap<SimBranchID, TreeSet<SimPreciseInv>> unverifiableWrites, byte[] objState, AcceptVV omitVV, NodeId bid){
//    this.unverifiableWrites = unverifiableWrites;
//    this.bid = bid;
//    this.omitVV = omitVV;
//    this.objectStateHash = objState;
//  }
//  
//  // define equals and compareTO
//  
  public boolean equals(Object o){
    if(!(o instanceof GCProposal)){
      return false;
    }else{
      GCProposal ep = (GCProposal)o;
        return omitVV.equals(ep.omitVV) && bid.equals(ep.bid) && this.epoch == ep.epoch;
        //unverifiableWrites.equals(ep.unverifiableWrites) && Arrays.equals(objectStateHash, ep.objectStateHash);
      
    }
  }

  public int hashCode(){
    return bid.hashCode()  + omitVV.hashCode() + new Integer(epoch).hashCode();
  }
  
  public int compareTo(Object o) throws ClassCastException{
    if(!(o instanceof GCProposal)){
      throw new ClassCastException(o + " not instanceof EvictionProposal");
    }else{
      GCProposal ep = (GCProposal)o;
      if(omitVV.includes(ep.omitVV) && !ep.omitVV.includes(omitVV)){
        return 1;
      }else if(omitVV.includes(ep.omitVV)){
        if(bid.gt(ep.bid)){
          return 1;
        }else if(bid.lt(ep.bid)){
          return -1;
        }else{
          return new Integer(epoch).compareTo(ep.epoch);
        }
        
      }else{
        assert ep.omitVV.includes(omitVV);
        return -1;
      }
    }
  }

}
